# Robotics Assignment: 2-DOF Planar Robot Arm

This assignment focuses on implementing a simulation environment for a 2-DOF planar robot arm using PyBullet. Students will also implement a control algorithm to solve the given problem.

## Getting Started

### Prerequisites

Install the required Python packages:

`pip install pybullet numpy`


### Setting Up the Environment

1. Download the URDF file for the 2-DOF planar robot arm and save it to a known location.
2. Create a list of obstacle IDs for the obstacles in the environment. You can create obstacles using the `pybullet.loadURDF()` function.
3. Replace the `urdf_file` variable in the `main()` function with the path to the downloaded URDF file.

### Running the Code

Run the Python script containing the main file, which loads the URDF, sets up the PyBullet environment, and checks for collisions and goal achievement:

`python main.py`

This script will output whether the test configuration is in collision or not, and if it has reached the goal position.

## Implementing the Control Algorithm

Students are expected to implement a control algorithm to solve the problem. The assignment provides a template for the simulation environment, collision checking, and goal achievement checking.

To complete the assignment, students should implement the following:

1. A control algorithm to guide the robot arm to the goal position while avoiding obstacles.
2. Modify the provided code to include their control algorithm.
3. Test the algorithm and analyze the results.

## Submission

Submit your Python script along with a report explaining your control algorithm, any challenges you faced, and the results of your tests.



